## pftools 3.2.12

=== CMakeLists.txt ===
# CMakeLists.txt
#
#
# This file allows building PCRE with the CMake configuration and build
# tool. Download CMake in source or binary form from http://www.cmake.org/
#
# Original listfile by Christian Ehrlicher <Ch.Ehrlicher@gmx.de>
# Refined and expanded by Daniel Richard G. <skunk@iSKUNK.ORG>
# 2007-09-14 mod by Sheri so 7.4 supported configuration options can be entered
# 2007-09-19 Adjusted by PH to retain previous default settings
# 2007-12-26 (a) On UNIX, use names libpcre instead of just pcre
#            (b) Ensure pcretest and pcregrep link with the local library,
#                not a previously-installed one.
#            (c) Add PCRE_SUPPORT_LIBREADLINE, PCRE_SUPPORT_LIBZ, and
#                PCRE_SUPPORT_LIBBZ2.
# 2008-01-20 Brought up to date to include several new features by Christian
#            Ehrlicher.
# 2008-01-22 Sheri added options for backward compatibility of library names
#            when building with minGW:
#            if "ON", NON_STANDARD_LIB_PREFIX causes shared libraries to
#            be built without "lib" as prefix. (The libraries will be named
#            pcre.dll, pcreposix.dll and pcrecpp.dll).
#            if "ON", NON_STANDARD_LIB_SUFFIX causes shared libraries to
#            be built with suffix of "-0.dll". (The libraries will be named
#            libpcre-0.dll, libpcreposix-0.dll and libpcrecpp-0.dll - same names
#            built by default with Configure and Make.
# 2008-01-23 PH removed the automatic build of pcredemo.
# 2008-04-22 PH modified READLINE support so it finds NCURSES when needed.
# 2008-07-03 PH updated for revised UCP property support (change of files)
# 2009-03-23 PH applied Steven Van Ingelgem's patch to change the name
#            CMAKE_BINARY_DIR to PROJECT_BINARY_DIR so that it works when PCRE
#            is included within another project.
# 2009-03-23 PH applied a modified version of Steven Van Ingelgem's patches to
#            add options to stop the building of pcregrep and the tests, and
#            to disable the final configuration report.
# 2009-04-11 PH applied Christian Ehrlicher's patch to show compiler flags that
#            are set by specifying a release type.
# 2010-01-02 PH added test for stdint.h
# 2010-03-02 PH added test for inttypes.h
# 2011-08-01 PH added PCREGREP_BUFSIZE
# 2011-08-22 PH added PCRE_SUPPORT_JIT
# 2011-09-06 PH modified WIN32 ADD_TEST line as suggested by Sergey Cherepanov
# 2011-09-06 PH added PCRE_SUPPORT_PCREGREP_JIT
# 2011-10-04 Sheri added support for including coff data in windows shared libraries
#            compiled with MINGW if pcre.rc and/or pcreposix.rc are placed in
#            the source dir by the user prior to building
# 2011-10-04 Sheri changed various add_test's to use exes' location built instead
#            of DEBUG location only (likely only matters in MSVC)
# 2011-10-04 Sheri added scripts to provide needed variables to RunTest and
#            RunGrepTest (used for UNIX and Msys)
# 2011-10-04 Sheri added scripts to provide needed variables and to execute
#            RunTest.bat in Win32 (for effortless testing with "make test")
# 2011-10-04 Sheri Increased minimum required cmake version
# 2012-01-06 PH removed pcre_info.c and added pcre_string_utils.c
# 2012-01-10 Zoltan Herczeg added libpcre16 support
# 2012-01-13 Stephen Kelly added out of source build support
# 2012-01-17 PH applied Stephen Kelly's patch to parse the version data out
#            of the configure.ac file
# 2012-02-26 PH added support for libedit
# 2012-09-06 PH added support for PCRE_EBCDIC_NL25
# 2012-09-08 ChPe added PCRE32 support
# 2012-10-23 PH added support for VALGRIND and GCOV
# 2012-12-08 PH added patch from Daniel Richard G to quash some MSVC warnings
# 2013-07-01 PH realized that the "support" for GCOV was a total nonsense and
#            so it has been removed.
# 2013-10-08 PH got rid of the "source" command, which is a bash-ism (use ".")
# 2013-11-05 PH added support for PARENS_NEST_LIMIT
# 2016-03-01 PH applied Chris Wilson's patch for MSVC static build
# 2016-06-24 PH applied Chris Wilson's revised patch (adds a separate option)
# 2021-06-14 PH changed CMAKE_MODULE_PATH definition to add, not replace
# 2021-06-14 PH applied Wolfgang Stöggl's patch for generating pcre-config and
#            libpcre*.pc files (Bugzilla #2583)

PROJECT(PCRE C CXX)

# Increased minimum to 2.8.5 to support GNUInstallDirs. Set policy
# CMP0026 to avoid warnings for the use of LOCATION in GET_TARGET_PROPERTY.

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.5)
CMAKE_POLICY(SET CMP0026 OLD)

# For FindReadline.cmake. This was changed to allow setting CMAKE_MODULE_PATH
# on the command line.
# SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake) # for FindReadline.cmake

LIST(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

# external packages
FIND_PACKAGE( BZip2 )
FIND_PACKAGE( ZLIB )
FIND_PACKAGE( Readline )
FIND_PACKAGE( Editline )

# Configuration checks

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckTypeSize)
INCLUDE(GNUInstallDirs) # for CMAKE_INSTALL_LIBDIR

CHECK_INCLUDE_FILE(dirent.h     HAVE_DIRENT_H)
CHECK_INCLUDE_FILE(stdint.h     HAVE_STDINT_H)
CHECK_INCLUDE_FILE(inttypes.h   HAVE_INTTYPES_H)
CHECK_INCLUDE_FILE(sys/stat.h   HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE(sys/types.h  HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE(unistd.h     HAVE_UNISTD_H)
CHECK_INCLUDE_FILE(windows.h    HAVE_WINDOWS_H)

CHECK_INCLUDE_FILE_CXX(type_traits.h            HAVE_TYPE_TRAITS_H)
CHECK_INCLUDE_FILE_CXX(bits/type_traits.h       HAVE_BITS_TYPE_TRAITS_H)

CHECK_FUNCTION_EXISTS(bcopy     HAVE_BCOPY)
CHECK_FUNCTION_EXISTS(memmove   HAVE_MEMMOVE)
CHECK_FUNCTION_EXISTS(strerror  HAVE_STRERROR)
CHECK_FUNCTION_EXISTS(strtoll   HAVE_STRTOLL)
CHECK_FUNCTION_EXISTS(strtoq    HAVE_STRTOQ)
CHECK_FUNCTION_EXISTS(_strtoi64 HAVE__STRTOI64)

CHECK_TYPE_SIZE("long long"             LONG_LONG)
CHECK_TYPE_SIZE("unsigned long long"    UNSIGNED_LONG_LONG)

# User-configurable options
#
# (Note: CMakeSetup displays these in alphabetical order, regardless of
# the order we use here)

SET(BUILD_SHARED_LIBS OFF CACHE BOOL
    "Build shared libraries instead of static ones.")

OPTION(PCRE_BUILD_PCRE8 "Build 8 bit PCRE library" ON)

OPTION(PCRE_BUILD_PCRE16 "Build 16 bit PCRE library" OFF)

OPTION(PCRE_BUILD_PCRE32 "Build 32 bit PCRE library" OFF)

OPTION(PCRE_BUILD_PCRECPP "Build the PCRE C++ library (pcrecpp)." ON)

SET(PCRE_EBCDIC OFF CACHE BOOL
    "Use EBCDIC coding instead of ASCII. (This is rarely used outside of mainframe systems.)")

SET(PCRE_EBCDIC_NL25 OFF CACHE BOOL
    "Use 0x25 as EBCDIC NL character instead of 0x15; implies EBCDIC.")

SET(PCRE_LINK_SIZE "2" CACHE STRING
    "Internal link size (2, 3 or 4 allowed). See LINK_SIZE in config.h.in for details.")

SET(PCRE_PARENS_NEST_LIMIT "250" CACHE STRING
    "Default nested parentheses limit. See PARENS_NEST_LIMIT in config.h.in for details.")

SET(PCRE_MATCH_LIMIT "10000000" CACHE STRING
    "Default limit on internal looping. See MATCH_LIMIT in config.h.in for details.")

SET(PCRE_MATCH_LIMIT_RECURSION "MATCH_LIMIT" CACHE STRING
    "Default limit on internal recursion. See MATCH_LIMIT_RECURSION in config.h.in for details.")

SET(PCREGREP_BUFSIZE "20480" CACHE STRING
    "Buffer size parameter for pcregrep. See PCREGREP_BUFSIZE in config.h.in for details.")

SET(PCRE_NEWLINE "LF" CACHE STRING
    "What to recognize as a newline (one of CR, LF, CRLF, ANY, ANYCRLF).")

SET(PCRE_NO_RECURSE OFF CACHE BOOL
    "If ON, then don't use stack recursion when matching. See NO_RECURSE in config.h.in for details.")

SET(PCRE_POSIX_MALLOC_THRESHOLD "10" CACHE STRING
    "Threshold for malloc() usage. See POSIX_MALLOC_THRESHOLD in config.h.in for details.")

SET(PCRE_SUPPORT_JIT OFF CACHE BOOL
    "Enable support for Just-in-time compiling.")

SET(PCRE_SUPPORT_PCREGREP_JIT ON CACHE BOOL
    "Enable use of Just-in-time compiling in pcregrep.")

SET(PCRE_SUPPORT_UTF OFF CACHE BOOL
    "Enable support for Unicode Transformation Format (UTF-8/UTF-16/UTF-32) encoding.")

SET(PCRE_SUPPORT_UNICODE_PROPERTIES OFF CACHE BOOL
    "Enable support for Unicode properties (if set, UTF support will be enabled as well).")

SET(PCRE_SUPPORT_BSR_ANYCRLF OFF CACHE BOOL
    "ON=Backslash-R matches only LF CR and CRLF, OFF=Backslash-R matches all Unicode Linebreaks")

SET(PCRE_SUPPORT_VALGRIND OFF CACHE BOOL
    "Enable Valgrind support.")

OPTION(PCRE_SHOW_REPORT    "Show the final configuration report" ON)
OPTION(PCRE_BUILD_PCREGREP "Build pcregrep" ON)
OPTION(PCRE_BUILD_TESTS    "Build the tests" ON)

IF (MINGW)
  OPTION(NON_STANDARD_LIB_PREFIX
         "ON=Shared libraries built in mingw will be named pcre.dll, etc., instead of libpcre.dll, etc."
         OFF)

  OPTION(NON_STANDARD_LIB_SUFFIX
         "ON=Shared libraries built in mingw will be named libpcre-0.dll, etc., instead of libpcre.dll, etc."
         OFF)
ENDIF(MINGW)

IF(MSVC)
  OPTION(PCRE_STATIC_RUNTIME
	"ON=Compile against the static runtime (/MT)."
	OFF)
  OPTION(INSTALL_MSVC_PDB
         "ON=Install .pdb files built by MSVC, if generated"
         OFF)
ENDIF(MSVC)

# bzip2 lib
IF(BZIP2_FOUND)
  OPTION (PCRE_SUPPORT_LIBBZ2 "Enable support for linking pcregrep with libbz2." ON)
ENDIF(BZIP2_FOUND)
IF(PCRE_SUPPORT_LIBBZ2)
  INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
ENDIF(PCRE_SUPPORT_LIBBZ2)

# zlib
IF(ZLIB_FOUND)
  OPTION (PCRE_SUPPORT_LIBZ "Enable support for linking pcregrep with libz." ON)
ENDIF(ZLIB_FOUND)
IF(PCRE_SUPPORT_LIBZ)
  INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
ENDIF(PCRE_SUPPORT_LIBZ)

# editline lib
IF(EDITLINE_FOUND)
  OPTION (PCRE_SUPPORT_LIBEDIT  "Enable support for linking pcretest with libedit." OFF)
ENDIF(EDITLINE_FOUND)
IF(PCRE_SUPPORT_LIBEDIT)
  INCLUDE_DIRECTORIES(${EDITLINE_INCLUDE_DIR})
ENDIF(PCRE_SUPPORT_LIBEDIT)

# readline lib
IF(READLINE_FOUND)
  OPTION (PCRE_SUPPORT_LIBREADLINE  "Enable support for linking pcretest with libreadline." ON)
ENDIF(READLINE_FOUND)
IF(PCRE_SUPPORT_LIBREADLINE)
  INCLUDE_DIRECTORIES(${READLINE_INCLUDE_DIR})
ENDIF(PCRE_SUPPORT_LIBREADLINE)

# Prepare build configuration

SET(pcre_have_type_traits 0)
SET(pcre_have_bits_type_traits 0)

IF(HAVE_TYPE_TRAITS_H)
        SET(pcre_have_type_traits 1)
ENDIF(HAVE_TYPE_TRAITS_H)

IF(HAVE_BITS_TYPE_TRAITS_H)
        SET(pcre_have_bits_type_traits 1)
ENDIF(HAVE_BITS_TYPE_TRAITS_H)

SET(pcre_have_long_long 0)
SET(pcre_have_ulong_long 0)

IF(HAVE_LONG_LONG)
        SET(pcre_have_long_long 1)
ENDIF(HAVE_LONG_LONG)

IF(HAVE_UNSIGNED_LONG_LONG)
        SET(pcre_have_ulong_long 1)
ENDIF(HAVE_UNSIGNED_LONG_LONG)

IF(NOT BUILD_SHARED_LIBS)
        SET(PCRE_STATIC 1)
ENDIF(NOT BUILD_SHARED_LIBS)

IF(NOT PCRE_BUILD_PCRE8 AND NOT PCRE_BUILD_PCRE16 AND NOT PCRE_BUILD_PCRE32)
        MESSAGE(FATAL_ERROR "At least one of PCRE_BUILD_PCRE8, PCRE_BUILD_PCRE16 or PCRE_BUILD_PCRE32 must be enabled")
ENDIF(NOT PCRE_BUILD_PCRE8 AND NOT PCRE_BUILD_PCRE16 AND NOT PCRE_BUILD_PCRE32)

IF(PCRE_BUILD_PCRE8)
        SET(SUPPORT_PCRE8 1)
ENDIF(PCRE_BUILD_PCRE8)

IF(PCRE_BUILD_PCRE16)
        SET(SUPPORT_PCRE16 1)
ENDIF(PCRE_BUILD_PCRE16)

IF(PCRE_BUILD_PCRE32)
        SET(SUPPORT_PCRE32 1)
ENDIF(PCRE_BUILD_PCRE32)

IF(PCRE_BUILD_PCRECPP AND NOT PCRE_BUILD_PCRE8)
        MESSAGE(STATUS "** PCRE_BUILD_PCRE8 must be enabled for the C++ library support")
        SET(PCRE_BUILD_PCRECPP OFF)
ENDIF(PCRE_BUILD_PCRECPP AND NOT PCRE_BUILD_PCRE8)

IF(PCRE_BUILD_PCREGREP AND NOT PCRE_BUILD_PCRE8)
        MESSAGE(STATUS "** PCRE_BUILD_PCRE8 must be enabled for the pcregrep program")
        SET(PCRE_BUILD_PCREGREP OFF)
ENDIF(PCRE_BUILD_PCREGREP AND NOT PCRE_BUILD_PCRE8)

IF(PCRE_SUPPORT_LIBREADLINE AND PCRE_SUPPORT_LIBEDIT)
        MESSAGE(FATAL_ERROR "Only one of libreadline or libeditline can be specified")
ENDIF(PCRE_SUPPORT_LIBREADLINE AND PCRE_SUPPORT_LIBEDIT)

IF(PCRE_SUPPORT_BSR_ANYCRLF)
        SET(BSR_ANYCRLF 1)
ENDIF(PCRE_SUPPORT_BSR_ANYCRLF)

IF(PCRE_SUPPORT_UTF OR PCRE_SUPPORT_UNICODE_PROPERTIES)

=== data/CMakeLists.txt ===
#########################################################################################
## Data files

SET(CalibrationFiles
    Calibration/window20.seq
    Calibration/reversed.seq
)


IF(BUILD_TESTING)
# 	IF (NOT EXISTS ${PROJECT_BINARY_DIR}/prosite.dat)
# 		MESSAGE(STATUS "Downloading prosite.dat")
# 		FILE(DOWNLOAD ftp://ftp.expasy.org/databases/prosite/prosite.dat ${PROJECT_BINARY_DIR}/prosite.dat INACTIVITY_TIMEOUT 60 STATUS PROSITE_OK)
# 		IF(NOT PROSITE_OK)
# 			MESSAGE(WARNING "Unable to download prosite.dat from the Internet.")
# 		ENDIF(NOT PROSITE_OK)
# 	ENDIF (NOT EXISTS ${PROJECT_BINARY_DIR}/prosite.dat)
#
# 	IF (NOT EXISTS ${PROJECT_BINARY_DIR}/uniprot_sprot.fasta.gz)
# 		MESSAGE(STATUS "Downloading uniprot_sprot.fasta.gz")
# 		FILE(DOWNLOAD ftp://ftp.uniprot.org/pub/databases/uniprot/current_release/knowledgebase/complete/uniprot_sprot.fasta.gz ${PROJECT_BINARY_DIR}/uniprot_sprot.fasta.gz INACTIVITY_TIMEOUT 60 STATUS SWISSPROT_OK)
# 		IF(NOT SWISSPROT_OK)
# 			MESSAGE(WARNING "Unable to download uniprot_sprot.fasta.gz from the Internet.")
# 		ENDIF(NOT SWISSPROT_OK)
# 		execute_process(
# 			COMMAND ${CMAKE_COMMAND} -E tar xzf ${PROJECT_BINARY_DIR}/uniprot_sprot.fasta.gz
# 			WORKING_DIRECTORY${PROJECT_BINARY_DIR}
# 		)
# 	ENDIF (NOT EXISTS ${PROJECT_BINARY_DIR}/uniprot_sprot.fasta.gz)
ENDIF(BUILD_TESTING)

# Find all the input files
# FILE(GLOB PrfFiles RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
#     "${CMAKE_CURRENT_SOURCE_DIR}/prf/*.prf")
#
# FILE(GLOB PrfSeqFiles RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
#     "${CMAKE_CURRENT_SOURCE_DIR}/prfseq/*.msa")

FILE(GLOB blossum   Matrices/*.cmp)
FILE(GLOB reverse   reverse/*)
FILE(GLOB familyPrf FamilyProfile/*)

INSTALL(FILES  ${CalibrationFiles}
	DESTINATION ${DATA_PATH}/calibration
	PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
	COMPONENT DataCalibration
)

INSTALL(FILES  ${blossum}
	DESTINATION ${DATA_PATH}/cmp
	PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
	COMPONENT DataBlossum
)

INSTALL(FILES  ${reverse}
	DESTINATION ${DATA_PATH}/reverse
	PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
	COMPONENT DataReverse
)

INSTALL(FILES  ${familyPrf}
	DESTINATION ${DATA_PATH}/familyProfile
	PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
	COMPONENT DataFamPrf
)

#INSTALL(FILES  ${PrfFiles}
# 	DESTINATION ${DATA_PATH}/prf
# 	PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
# 	COMPONENT DataPrf
#)
#
#INSTALL(FILES  ${PrfSeqFiles}
# 	DESTINATION ${DATA_PATH}/prfseq
# 	PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
# 	COMPONENT DataPrfSeq
#)
#
# INSTALL(FILES uniprot.fas
# 	DESTINATION ${DATA_PATH}/uniprot/
# 	PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
# 	COMPONENT DataUniprot
#)

=== doc/CMakeLists.txt ===
# Process documentation for the PLplot project.

# Process man pages in this subdirectory.

set(core_manpages pltek.1)

if(PLD_pstex)
  set(core_manpages ${core_manpages} pstex2eps.1)
endif(PLD_pstex)

if(PLD_plmeta)
  set(core_manpages ${core_manpages} plrender.1 plm2gif.1 plpr.1)
endif(PLD_plmeta)

set(tcl_manpages plserver.1 pltcl.1)

set(manpages ${core_manpages})
if (ENABLE_tcl)
  set(manpages ${manpages} ${tcl_manpages})
endif (ENABLE_tcl)

install(FILES ${manpages} DESTINATION ${MAN_DIR}/man1)

# Process the docbook documentation.
add_subdirectory(docbook) 

# Process the doxygen documentation.

if(BUILD_DOX_DOC)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY
    )

  # Attempt to collect the same source-code files that are specified
  # by the INPUT parameter in Doxyfile(.in).  Note, this includes
  # all configured files in the build tree because all source
  # subdirectories are processed by the top-level CMakeLists.txt file
  # before this doc subdirectory.  However, these dependencies will
  # miss at cmake time the files in the build tree that are generated
  # at run time.

  set(doxygen_prefixes  "*.c;*.cc;*.cxx;*.cpp;*.c++;*.d;*.java;*.h;*.py;*.f90;*.f")
  set(doxygen_directories 
    ${CMAKE_SOURCE_DIR}/lib
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_SOURCE_DIR}/drivers
    ${CMAKE_SOURCE_DIR}/bindings
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/lib
    ${CMAKE_BINARY_DIR}/bindings
    ${CMAKE_BINARY_DIR}/include
    )
  set(doxygen_globs )
  foreach(directory ${doxygen_directories})
    foreach(prefix ${doxygen_prefixes})
      list(APPEND doxygen_globs ${directory}/${prefix})
    endforeach(prefix ${doxygen_prefixes})
  endforeach(directory ${doxygen_directories})
  # Must append one specific configured file to be consistent with
  # the INPUT parameter in Doxyfile(.in).
  list(APPEND doxygen_globs ${CMAKE_BINARY_DIR}/plplot_config.h)
  #message(STATUS "DEBUG: doxygen_globs = ${doxygen_globs}")

  # RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} works (because that is the
  # [default] working directory for running the doxygen command) and makes the
  # resulting paths substantially shorter, but is actually not
  # necessary.
  file(GLOB_RECURSE doxygen_file_depends
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    ${doxygen_globs}
    )
  #message(STATUS "DEBUG: doxygen_file_depends = ${doxygen_file_depends}")

  # Notes: OUTPUT file is a directory so this insures "make clean"
  # removes that directory.
  add_custom_command(
    OUTPUT
    ${CMAKE_CURRENT_BINARY_DIR}/doxygen
    COMMAND ${DOXYGEN_EXECUTABLE}
    DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    ${doxygen_file_depends}
    )
  add_custom_target(build_doxygen ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doxygen
    )

  # Add some library dependencies that will insure all run-time
  # generated source files will be correctly processed by doxygen.
  # These won't have the proper file dependencies (see comment above)
  # so the doxygen documentation won't be remade if one of these
  # run-time files is regenerated, but source-file regeneration (which
  # would be caused by editing one of the prerequisites of these
  # generated source files) should be a rare case in practice.
  add_dependencies(build_doxygen plplot)
  # Generated C code for the Tcl bindings.
  if(ENABLE_tcl)
    add_dependencies(build_doxygen plplottcltk)
  endif(ENABLE_tcl)
  # Generated C (and C++ in the Octave case) code for the
  # swig-generated bindings.
  if(ENABLE_python)
    add_dependencies(build_doxygen _plplotcmodule)
  endif(ENABLE_python)
  if(ENABLE_java)
    add_dependencies(build_doxygen plplotjavac_wrap)
  endif(ENABLE_java)
  if(ENABLE_lua)
    add_dependencies(build_doxygen plplotluac)
  endif(ENABLE_lua)
  if(ENABLE_octave)
    add_dependencies(build_doxygen plplot_octave)
  endif(ENABLE_octave)

  install(CODE "
message(STATUS \"Installing: \$ENV{DESTDIR}${DOC_DIR}/doxygen tree\")
execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_BINARY_DIR}/doxygen \$ENV{DESTDIR}${DOC_DIR}/doxygen)
")
  if(DEFINED WWW_USER AND DEFINED WWW_HOST AND DEFINED WWW_DIR)
    add_custom_target(
      www-install-doxygen
      ssh ${WWW_USER}@${WWW_HOST} mkdir -p ${WWW_DIR}/htdocs/doxygen
      COMMAND rsync -avq ${CMAKE_CURRENT_BINARY_DIR}/doxygen/ ${WWW_USER}@${WWW_HOST}:${WWW_DIR}/htdocs/doxygen
      )
    add_dependencies(www-install-doxygen build_doxygen) 
  endif(DEFINED WWW_USER AND DEFINED WWW_HOST AND DEFINED WWW_DIR)
endif(BUILD_DOX_DOC)

=== fonts/CMakeLists.txt ===
# fonts/CMakeLists.txt
# N.B. the plhershey-unicode-gen stuff is taken care of by
# ../include/CMakeLists.txt.  This file only used to optionally build the
# Hershey fonts.

option(BUILD_HERSHEY_FONTS "Build Hershey fonts?" OFF)

if(BUILD_HERSHEY_FONTS)

  # Build Hershey fonts.

  # Create "convenience static library" to help build Hershey fonts.

  set(libhershey_SRC
    font01.c
    font02.c
    font03.c
    font04.c
    font05.c
    font06.c
    font07.c
    font08.c
    font09.c
    font10.c
    font11.c
    )

  include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime    
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    )
  add_library(hershey STATIC ${libhershey_SRC})

  if(BUILD_SHARED_LIBS)
    set_source_files_properties(stndfont.c
      PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
  endif(BUILD_SHARED_LIBS)
  add_executable(generate_stndfonts stndfont.c)
  target_link_libraries(generate_stndfonts hershey plplot)

  if(BUILD_SHARED_LIBS)
    set_source_files_properties(xstndfont.c
      PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
  endif(BUILD_SHARED_LIBS)
  add_executable(generate_xtndfonts xtndfont.c)
  target_link_libraries(generate_xtndfonts hershey plplot)

endif(BUILD_HERSHEY_FONTS)

=== man/CMakeLists.txt ===
#########################################################################################
## man files

# Find all the input files
FILE(GLOB ManFiles1 RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
	"${CMAKE_CURRENT_SOURCE_DIR}/*.1")

INSTALL(FILES  ${ManFiles1}
	DESTINATION ${MAN1_PATH}
	PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
	COMPONENT Documentation
)


FILE(GLOB ManFiles5 RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
	"${CMAKE_CURRENT_SOURCE_DIR}/*.5")

INSTALL(FILES  ${ManFiles5}
	DESTINATION ${MAN5_PATH}
	PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
	COMPONENT Documentation
)

=== src/CMakeLists.txt ===
# src/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006-2015 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

set(plplot_LIB_SRCS
  pdfutils.c
  plmem.c
  plaffine.c
  plarc.c
  plargs.c
  plbox.c
  plcont.c
  plcore.c
  plctrl.c
  plcvt.c
  pldtik.c
  plf2ops.c
  plfill.c
  plfreetype.c
  plgradient.c
  plhist.c
  plimage.c
  plline.c
  plmap.c
  plmetafile.c
  plot3d.c
  plpage.c
  plsdef.c
  plshade.c
  plstdio.c
  plstripc.c
  plsym.c
  pltick.c
  plvpor.c
  plwind.c
  plbuf.c
  plgridd.c
  plvect.c
  mt19937ar.c
  pltime.c
  pllegend.c
  )
if(PL_DEPRECATED)
  set(plplot_LIB_SRCS ${plplot_LIB_SRCS} pldeprecated.c)
endif(PL_DEPRECATED)
if(LTDL_WIN32)
  set(plplot_LIB_SRCS ${plplot_LIB_SRCS} ltdl_win32.c)
endif(LTDL_WIN32)

if(BUILD_SHARED_LIBS)
  set_source_files_properties(${plplot_LIB_SRCS}
    PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
endif(BUILD_SHARED_LIBS)

option(HERSHEY_FALLBACK "Hershey fallback for Unicode fonts" ON)

if(NOT HERSHEY_FALLBACK)
  get_source_file_property(PLSYM_COMPILE_PROPS plsym.c COMPILE_FLAGS)
  if(NOT PLSYM_COMPILE_PROPS)
    set(PLSYM_COMPILE_PROPS)
  endif(NOT PLSYM_COMPILE_PROPS)
  set_source_files_properties(
    plsym.c
    PROPERTIES COMPILE_FLAGS "${PLSYM_COMPILE_PROPS} -DPL_TEST_FOR_MISSING_GLYPHS"
    )
endif(NOT HERSHEY_FALLBACK)

set(libplplot_COMPILE_FLAGS)
if(ENABLE_DYNDRIVERS)
  get_source_file_property(PLCORE_COMPILE_PROPS plcore.c COMPILE_FLAGS)
  # Deal with NOTFOUND case.
  if(NOT PLCORE_COMPILE_PROPS)
    set(PLCORE_COMPILE_PROPS)
  endif(NOT PLCORE_COMPILE_PROPS)
  set_source_files_properties(
    plcore.c
    PROPERTIES COMPILE_FLAGS "${PLCORE_COMPILE_PROPS} -I${LTDL_INCLUDE_DIR}"
    )
else(ENABLE_DYNDRIVERS)
  if(ENABLE_tcl)
    set(
      tclgenfiles
      ${CMAKE_BINARY_DIR}/bindings/tcl/tclgen.h
      ${CMAKE_BINARY_DIR}/bindings/tcl/tclgen_s.h
      ${CMAKE_BINARY_DIR}/bindings/tcl/tclgen.c
      )

    # Only need to set up this special command if either the tk and tkwin
    # non-dynamic devices are enabled (see below) since at build time
    # this special command is only fired in that case.
    add_custom_command(
      OUTPUT ${tclgenfiles}
      COMMAND ${TCL_TCLSH}
      ${CMAKE_SOURCE_DIR}/bindings/tcl/pltclgen.tcl
      ${CMAKE_SOURCE_DIR}/bindings/tcl
      DEPENDS
      ${CMAKE_SOURCE_DIR}/bindings/tcl/pltclgen.tcl
      ${CMAKE_SOURCE_DIR}/bindings/tcl/plapi.tpl
      ${CMAKE_SOURCE_DIR}/bindings/tcl/tclcmd.tpl
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/bindings/tcl
      )
  endif(ENABLE_tcl)

  # Static device drivers must be included in the core PLplot library.
  set(DRIVERS_RPATH)
  foreach(SOURCE_ROOT_NAME ${DRIVERS_LIST})
    #message("${SOURCE_ROOT_NAME}_SOURCE = ${${SOURCE_ROOT_NAME}_SOURCE}")
    list(APPEND plplot_LIB_SRCS ${${SOURCE_ROOT_NAME}_SOURCE})

    if(SOURCE_ROOT_NAME STREQUAL "qt")
      if(ANY_QT_DEVICE)
	# For this case libplot must have a target dependency on the
	# moc files generated in the binary include directory.
	set(qt_dependency moc_outfile_generated)

	# Qt5 handled a completely different way.
	if(NOT PLPLOT_USE_QT5)
	  if(NOT QT_LIBRARIES)
	    message(FATAL_ERROR "include(${QT_USE_FILE}) failed in src subdirectory.")
	  endif(NOT QT_LIBRARIES)
	  set(DRIVERS_LINK_FLAGS ${DRIVERS_LINK_FLAGS} ${QT_LIBRARIES})
	endif(NOT PLPLOT_USE_QT5)
	
      else(ANY_QT_DEVICE)
	message(FATAL_ERROR "Internal build system inconsistency.  Attempt to build static qt device when ANY_QT_DEVICE is false.")
      endif(ANY_QT_DEVICE)
    endif(SOURCE_ROOT_NAME STREQUAL "qt")
    
    # qt device driver code within libplplot has some symbols that need to be
    # visible for qt_example in installed examples/c++ directory to link 
    # properly. 
    if(BUILD_SHARED_LIBS AND SOURCE_ROOT_NAME STREQUAL "qt")
      set(${SOURCE_ROOT_NAME}_COMPILE_FLAGS "${${SOURCE_ROOT_NAME}_COMPILE_FLAGS} -DUSINGDLL")
    endif(BUILD_SHARED_LIBS AND SOURCE_ROOT_NAME STREQUAL "qt")

    if(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)
      set_source_files_properties(
	${${SOURCE_ROOT_NAME}_SOURCE}
	PROPERTIES COMPILE_FLAGS ${${SOURCE_ROOT_NAME}_COMPILE_FLAGS}
	)
      list(APPEND libplplot_COMPILE_FLAGS ${${SOURCE_ROOT_NAME}_COMPILE_FLAGS})
      if(SOURCE_ROOT_NAME STREQUAL "tk")
        set_source_files_properties(
	  ${${SOURCE_ROOT_NAME}_SOURCE}
	  PROPERTIES OBJECT_DEPENDS ${tclgenfiles}
	  )
      endif(SOURCE_ROOT_NAME STREQUAL "tk")
      if(SOURCE_ROOT_NAME STREQUAL "tkwin")
        set_source_files_properties(
	  ${${SOURCE_ROOT_NAME}_SOURCE}
	  PROPERTIES OBJECT_DEPENDS ${tclgenfiles}
	  )
      endif(SOURCE_ROOT_NAME STREQUAL "tkwin")
    endif(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)
    if(${SOURCE_ROOT_NAME}_RPATH)
      set(DRIVERS_RPATH ${DRIVERS_RPATH} ${${SOURCE_ROOT_NAME}_RPATH})
    endif(${SOURCE_ROOT_NAME}_RPATH)
  endforeach(SOURCE_ROOT_NAME ${DRIVERS_LIST})
endif(ENABLE_DYNDRIVERS)

include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/lib/qsastime
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/include
  )
add_library(plplot ${plplot_LIB_SRCS})
add_dependencies(plplot plhershey-unicode.h_built ${qt_dependency})

if(NOT ENABLE_DYNDRIVERS AND ANY_QT_DEVICE AND PLPLOT_USE_QT5)
  # According to advice from Steve Kelly on the Cmake list, the Qt5
  # Gui component is a dependency of the Qt5 Svg component so is not
  # needed here, but I will leave it in since it is informative.
  qt5_use_modules(plplot Svg Gui PrintSupport)
endif(NOT ENABLE_DYNDRIVERS AND ANY_QT_DEVICE AND PLPLOT_USE_QT5)

if(NON_TRANSITIVE)
  # empty list ==> non-transitive linking for everything that links to
  # libplplotd in the shared libraries case.
  target_link_libraries(plplot LINK_INTERFACE_LIBRARIES)
endif(NON_TRANSITIVE)

# Deal with external libraries.
set(LIB_INSTALL_RPATH ${LIB_DIR})
set(libplplot_LINK_LIBRARIES)
if(ENABLE_DYNDRIVERS)
  list(APPEND libplplot_LINK_LIBRARIES ${LTDL_LIBRARIES})
  #message("libplplot_LINK_LIBRARIES =  ${libplplot_LINK_LIBRARIES}")
  #message("libplplot_RPATH = ${libplplot_RPATH}")
  list(APPEND LIB_INSTALL_RPATH ${libplplot_RPATH})
else(ENABLE_DYNDRIVERS)
  list(APPEND libplplot_LINK_LIBRARIES ${DRIVERS_LINK_FLAGS})
  list(APPEND LIB_INSTALL_RPATH ${DRIVERS_RPATH})
  if(ANY_QT_DEVICE AND NOT PLPLOT_USE_QT5)
    # Update the target COMPILE_DEFINITIONS and INCLUDE_DIRECTORIES
    set_qt_target_properties(plplot)
  endif(ANY_QT_DEVICE AND NOT PLPLOT_USE_QT5)
endif(ENABLE_DYNDRIVERS)
#message("DEBUG: LIB_INSTALL_RPATH = ${LIB_INSTALL_RPATH}")

if(MATH_LIB)
  list(APPEND libplplot_LINK_LIBRARIES ${MATH_LIB})
endif(MATH_LIB)

if(HAVE_SHAPELIB)
  get_source_file_property(PLMAP_COMPILE_PROPS plmap.c COMPILE_FLAGS)
  # Deal with NOTFOUND case.
  if(NOT PLMAP_COMPILE_PROPS)
    set(PLMAP_COMPILE_PROPS)
  endif(NOT PLMAP_COMPILE_PROPS)
  set_source_files_properties(plmap.c 
    PROPERTIES
    COMPILE_FLAGS "${PLMAP_COMPILE_PROPS} -I${SHAPELIB_INCLUDE_DIR}"
    )
  if(HAVE_SAHOOKS)
  set_source_files_properties(plmap.c 
    PROPERTIES
    COMPILE_DEFINITIONS HAVE_SAHOOKS
    )
  endif(HAVE_SAHOOKS)

  list(APPEND libplplot_LINK_LIBRARIES ${SHAPELIB_LIBRARIES})
  list(APPEND LIB_INSTALL_RPATH ${SHAPELIB_RPATH})

endif(HAVE_SHAPELIB)

if(WITH_FREETYPE)
  get_source_file_property(PLFREETYPE_COMPILE_PROPS plfreetype.c COMPILE_FLAGS)
  # Deal with NOTFOUND case.
  if(NOT PLFREETYPE_COMPILE_PROPS)
    set(PLFREETYPE_COMPILE_PROPS)
  endif(NOT PLFREETYPE_COMPILE_PROPS)
  set_source_files_properties(plfreetype.c PROPERTIES COMPILE_FLAGS "${PLFREETYPE_COMPILE_PROPS} ${FREETYPE_INCLUDE_CFLAGS}")
  list(APPEND libplplot_LINK_LIBRARIES ${FREETYPE_LIBRARIES})
endif(WITH_FREETYPE)

set(libstdcxx_full_path)
if(ENABLE_cxx AND NOT BUILD_SHARED_LIBS)
  # For this special case where the plplot library is a static C++
  # library, pkg-config needs to add -L and -l options corresponding
  # to libstd++.so to the link flags it delivers.  Another alternative
  # is to have the plplot library link statically to libstd++.a, but
  # static linking is not well-supported in CMake, and I am attempting
  # to keep this fix limited to just the configuration of the
  # plplotd.pc pkg-config file.  N.B. the logic below for finding the
  # C++ library is extremely specific to GNU g++ (either Unix or MinGW
  # version), but it is good to get at least this compiler to work for
  # the special case of a static C++ plplot library.
  if(EXISTS "${CMAKE_CXX_COMPILER}")
    execute_process(
      COMMAND ${CMAKE_CXX_COMPILER} --verbose --version
      RESULT_VARIABLE CXX_rc
      ERROR_VARIABLE CXX_string
      ERROR_STRIP_TRAILING_WHITESPACE
      OUTPUT_QUIET
      )
  else(EXISTS "${CMAKE_CXX_COMPILER}")
    set(CXX_rc 2)
  endif(EXISTS "${CMAKE_CXX_COMPILER}")
  if(CXX_rc STREQUAL "0" AND CXX_string MATCHES "LIBRARY_PATH=")
    string(REGEX REPLACE "^.*(LIBRARY_PATH=.*)\nCOLLECT_GCC_OPTIONS.*$" "\\1"
      CXX_library_path_string "${CXX_string}"
      )
    #message(STATUS "CXX_library_path_string = ${CXX_library_path_string}")
    if(CXX_library_path_string MATCHES "^LIBRARY_PATH=")
      string(REGEX REPLACE "^LIBRARY_PATH=" "" CXX_library_path "${CXX_library_path_string}")
      # For both Linux and MinGW, CXX_library_path is a semicolon
      # delimited list which is identical to the form of a CMake list.
      # Furthermore, for the MinGW case, the drive letters are in the
      # colon form, but experiments show that is exactly the form
      # required by find_library for the MinGW case.  Net result: no
      # conversion necessary for either Linux or MinGW.
      find_library(libstdcxx_full_path NAMES stdc++ PATHS ${CXX_library_path})
      message(STATUS "libstdcxx_full_path = ${libstdcxx_full_path}")
    else(CXX_library_path_string MATCHES "^LIBRARY_PATH=")
      message(STATUS "WARNING: execute_process failed to obtain C++ library needed for pkg-config")
      message(STATUS "CXX_string = ${CXX_string}")
      message(STATUS "CXX_library_path_string = ${CXX_library_path_string}")
    endif(CXX_library_path_string MATCHES "^LIBRARY_PATH=")
  else(CXX_rc STREQUAL "0" AND CXX_string MATCHES "LIBRARY_PATH=")
    message(STATUS "WARNING: execute_process failed to obtain C++ library needed for pkg-config")
    message(STATUS "CMAKE_CXX_COMPILER = ${CMAKE_CXX_COMPILER}")
    message(STATUS "CXX_rc = ${CXX_rc}")
    message(STATUS "CXX_string = ${CXX_string}")
  endif(CXX_rc STREQUAL "0" AND CXX_string MATCHES "LIBRARY_PATH=")
  if(NOT libstdcxx_full_path)
    message(STATUS "WARNING: failed to find libstdc++ so pkg-config link flags will be incomplete") 
  endif(NOT libstdcxx_full_path)
endif(ENABLE_cxx AND NOT BUILD_SHARED_LIBS)

# Copy current information in libplplot_LINK_LIBRARIES
# into libplplot_LINK_FLAGS, which contains the equivalent list information
# in a combination of library list form and pkg-config form that will
# eventually be transformted into pure pkg-config form.  Both variables
# will have data added to them afterward due to the internal PLplot libraries
# which have a different pkg-config treatment than the external libraries
# dealt with here.
set(libplplot_LINK_FLAGS ${libplplot_LINK_LIBRARIES})

if(libstdcxx_full_path)
  list(APPEND libplplot_LINK_FLAGS ${libstdcxx_full_path})
endif(libstdcxx_full_path)

# The above completes dealing with the external libraries.  Now

=== tests/CMakeLists.txt ===
IF (NOT EXISTS "${TESTS_DIRECTORY}/examples")
	FILE(MAKE_DIRECTORY "${TESTS_DIRECTORY}/examples")
ENDIF (NOT EXISTS "${TESTS_DIRECTORY}/examples")
SET(EXAMPLES_TMP_DIR "${TESTS_DIRECTORY}/examples")
SET(EXAMPLES_DATA_DIR "${TESTS_DATA_DIR}/examples")
SET(PERL_SCRIPT_DIR "${PROJECT_SOURCE_DIR}/src/Perl")


FILE(GLOB EXAMPLES_FILES examples/*)

FILE(COPY ${EXAMPLES_FILES} DESTINATION ${TESTS_DIRECTORY}/examples/)

CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_V2.sh.cmake
               ${TESTS_DIRECTORY}/examples/test_V2.sh.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_V2.sh
              INPUT ${TESTS_DIRECTORY}/examples/test_V2.sh.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_V2.sh.cmake)

CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_V3.sh.cmake
               ${TESTS_DIRECTORY}/examples/test_V3.sh.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_V3.sh
              INPUT ${TESTS_DIRECTORY}/examples/test_V3.sh.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_V3.sh.cmake)

CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_V3_output.sh.cmake
               ${TESTS_DIRECTORY}/examples/test_V3_output.sh.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_V3_output.sh
              INPUT ${TESTS_DIRECTORY}/examples/test_V3_output.sh.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_V3_output.sh.cmake)

CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_pfsearchV3_iupac.pl.cmake
               ${TESTS_DIRECTORY}/examples/test_pfsearchV3_iupac.pl.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_pfsearchV3_iupac.pl
              INPUT ${TESTS_DIRECTORY}/examples/test_pfsearchV3_iupac.pl.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_pfsearchV3_iupac.pl.cmake)

CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_scan_search.pl.cmake
               ${TESTS_DIRECTORY}/examples/test_scan_search.pl.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_scan_search.pl
              INPUT ${TESTS_DIRECTORY}/examples/test_scan_search.pl.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_scan_search.pl.cmake)

CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_pfsearchV3_pattern-regexp.sh.cmake
               ${TESTS_DIRECTORY}/examples/test_pfsearchV3_pattern-regexp.sh.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_pfsearchV3_pattern-regexp.sh
              INPUT ${TESTS_DIRECTORY}/examples/test_pfsearchV3_pattern-regexp.sh.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_pfsearchV3_pattern-regexp.sh.cmake)


INSTALL(DIRECTORY examples/
        DESTINATION share/examples
        PATTERN "CMakeLists.txt" EXCLUDE
)
INSTALL(CODE "EXECUTE_PROCESS(COMMAND find ${CMAKE_INSTALL_PREFIX}/share/examples/ -type f -name \*.cmake -exec chmod a+rx {} \;)")
INSTALL(CODE "EXECUTE_PROCESS(COMMAND find ${CMAKE_INSTALL_PREFIX}/share/examples/ -type f -name \*.cmake -exec sed -i \"s|@DATA_DIR@/Matrices|${CMAKE_INSTALL_PREFIX}/share/data/cmp|; s|@PERL_SCRIPT_DIR@|${CMAKE_INSTALL_PREFIX}/bin|\" {} \;)")
INSTALL(CODE "EXECUTE_PROCESS(COMMAND find ${CMAKE_INSTALL_PREFIX}/share/examples/ -type f -name \*.cmake -exec perl -i -pe \"s|.<TARGET_FILE:(.+?)>|${CMAKE_INSTALL_PREFIX}/bin/$1|\" {} \;)")
INSTALL(CODE "FILE(RENAME ${CMAKE_INSTALL_PREFIX}/share/examples/test_V2.sh.cmake               ${CMAKE_INSTALL_PREFIX}/share/examples/test_V2.sh)")
INSTALL(CODE "FILE(RENAME ${CMAKE_INSTALL_PREFIX}/share/examples/test_V3.sh.cmake               ${CMAKE_INSTALL_PREFIX}/share/examples/test_V3.sh)")
INSTALL(CODE "FILE(RENAME ${CMAKE_INSTALL_PREFIX}/share/examples/test_scan_search.pl.cmake      ${CMAKE_INSTALL_PREFIX}/share/examples/test_scan_search.pl)")
INSTALL(CODE "FILE(RENAME ${CMAKE_INSTALL_PREFIX}/share/examples/test_pfsearchV3_iupac.pl.cmake ${CMAKE_INSTALL_PREFIX}/share/examples/test_pfsearchV3_iupac.pl)")

=== www/CMakeLists.txt ===
# www/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2008 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# Configure documentation file sizes.
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/documentation.php.in
  ${CMAKE_CURRENT_BINARY_DIR}/documentation.php @ONLY
  )

# Configure style files
add_subdirectory(css)

# Set up Makefile rules to generate announcements and validate their DocBook-XML source.
add_subdirectory(announce)

# Copy base website files to a staging area in the build tree.

set(staging_FILES)

# Create the staging directory tree at cmake time.
file(MAKE_DIRECTORY
  ${CMAKE_CURRENT_BINARY_DIR}/staging/
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce
  )

# Note documentation.php configured as above.
set(toplevel_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/corefunctions.php
  ${CMAKE_CURRENT_SOURCE_DIR}/credits.php
  ${CMAKE_CURRENT_SOURCE_DIR}/development.php
  ${CMAKE_CURRENT_SOURCE_DIR}/downloads.php
  ${CMAKE_CURRENT_SOURCE_DIR}/examples.php
  ${CMAKE_CURRENT_SOURCE_DIR}/index.php
  ${CMAKE_CURRENT_SOURCE_DIR}/simplepie.inc
  ${CMAKE_CURRENT_BINARY_DIR}/documentation.php
  )

foreach(_file ${toplevel_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/${_filename}
    )
endforeach(_file ${toplevel_FILES})

# Note style files configure by CMake above in the css (build) directory.
set(css_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/css/closelabel.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/loading.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/nextlabel.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/prevlabel.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/slimbox.css
  ${CMAKE_CURRENT_BINARY_DIR}/css/style_liquid.css
  ${CMAKE_CURRENT_BINARY_DIR}/css/style_static.css
  )

foreach(_file ${css_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css/${_filename}
    )
endforeach(_file ${css_FILES})

set(img_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/img/arrow.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/bg.jpg
  ${CMAKE_CURRENT_SOURCE_DIR}/img/content_bg.jpg
  ${CMAKE_CURRENT_SOURCE_DIR}/img/drop_shadow.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/header.jpg
  ${CMAKE_CURRENT_SOURCE_DIR}/img/menu_bg.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/menu_hover_bg.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/menu_selected_bg.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/plplot_logo.jpg
  )

foreach(_file ${img_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img/${_filename}
    )
endforeach(_file ${img_FILES})

set(js_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/js/slimbox.js
  )

foreach(_file ${js_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js/${_filename}
    )
endforeach(_file ${js_FILES})

# The end of this list needs maintenance for each new release announcement
# that is generated (assuming we start making formal release announcements
# again).
set(announce_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/ChangeLog-5.2.1-5.3.0
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/ChangeLog-5.3.0-5.3.1
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/ChangeLog-5.3.1-5.3.2
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/announce-plplot-5.1.0.html
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/announce-plplot-5.2.1.html
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/announce.css
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.0.xhtml
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.0.txt
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.1.xhtml
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.1.txt
  )

# This has to be handled differently because some of these files created
# with the announce subdirectory generate_announcements target.
set(staging_announce_FILES)
foreach(_file ${announce_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_announce_FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce/${_filename}
    )
endforeach(_file ${announce_FILES})

add_custom_target(
  create_staging_announce
  DEPENDS ${staging_announce_FILES}
  )
add_dependencies(create_staging_announce generate_announcements)

add_custom_target(
  create_staging
  DEPENDS ${staging_FILES}
  )
add_dependencies(create_staging create_staging_announce)

if(DEFINED WWW_USER AND DEFINED WWW_HOST AND DEFINED WWW_DIR)
  add_custom_target(
    www-install-base
    ssh ${WWW_USER}@${WWW_HOST} mkdir -p ${WWW_DIR}/htdocs
    COMMAND rsync -avq ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/ ${WWW_USER}@${WWW_HOST}:${WWW_DIR}/htdocs
    )
  add_dependencies(www-install-base create_staging) 
endif(DEFINED WWW_USER AND DEFINED WWW_HOST AND DEFINED WWW_DIR)

=== bindings/c++/CMakeLists.txt ===
# bindings/c++/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Andrew Ross
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_cxx)

  set(plplotcxx_LIB_SRCS
    plstream.cc
    )

  set(plplotcxx_INSTALLED_HEADERS
    plstream.h
    )

  # Set the include path
  include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    )

  # Create plplotcxx[d] library
  add_library(plplotcxx ${plplotcxx_LIB_SRCS})

  if(BUILD_SHARED_LIBS)
    set_source_files_properties(${plplotcxx_LIB_SRCS}
      PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
  endif(BUILD_SHARED_LIBS)

  target_link_libraries(plplotcxx plplot)
  if(NON_TRANSITIVE)
    # empty list ==> non-transitive linking for everything that links
    # to libplplotcxx in the shared libraries case.
    target_link_libraries(plplotcxx LINK_INTERFACE_LIBRARIES)
  endif(NON_TRANSITIVE)

  if(USE_RPATH)
    get_target_property(LIB_INSTALL_RPATH plplot INSTALL_RPATH)
    set_target_properties(plplotcxx
      PROPERTIES
      SOVERSION ${plplotcxx_SOVERSION}
      VERSION ${plplotcxx_VERSION}
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(plplotcxx
      PROPERTIES
      SOVERSION ${plplotcxx_SOVERSION}
      VERSION ${plplotcxx_VERSION}
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  endif(USE_RPATH)
  # Install library in lib/
  install(TARGETS plplotcxx
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
    )
  install(FILES
    ${plplotcxx_INSTALLED_HEADERS}
    DESTINATION ${INCLUDE_DIR}
    )

  # Configure pkg-config *.pc file corresponding to libplplotcxx
  pkg_config_file("c++" "C++" " C++ binding" "plplotcxx" "" "")

endif(ENABLE_cxx)

=== bindings/d/CMakeLists.txt ===
# bindings/d/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2008 Werner Smekal
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_d)
  set(d_interface_INSTALLED_HEADERS plplot.d )

  install(FILES ${d_interface_INSTALLED_HEADERS}
    DESTINATION ${INCLUDE_DIR}
  )

  # Build d bindings
  set(plplotdmd_LIB_SRCS
    plplot.d
  )

  if(plplotdmd_SHARED)
    add_library(plplotdmd ${plplotdmd_LIB_SRCS})

    if(BUILD_SHARED_LIBS)
      set_source_files_properties(${plplotdmd_LIB_SRCS}
	PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
    endif(BUILD_SHARED_LIBS)

    target_link_libraries(plplotdmd plplot)

    if(USE_RPATH)
      get_target_property(LIB_INSTALL_RPATH plplot INSTALL_RPATH)
      set_target_properties(plplotdmd
	PROPERTIES
	SOVERSION ${plplotdmd_SOVERSION}
	VERSION ${plplotdmd_VERSION}
	INSTALL_RPATH "${LIB_INSTALL_RPATH}"
	INSTALL_NAME_DIR "${LIB_DIR}"
	)
    else(USE_RPATH)
      set_target_properties(plplotdmd
	PROPERTIES
	SOVERSION ${plplotdmd_SOVERSION}
	VERSION ${plplotdmd_VERSION}
	INSTALL_NAME_DIR "${LIB_DIR}"
	)
    endif(USE_RPATH)
  else(plplotdmd_SHARED)
    add_library(plplotdmd STATIC ${plplotdmd_LIB_SRCS})
    target_link_libraries(plplotdmd plplot)
  endif(plplotdmd_SHARED)

  if(NON_TRANSITIVE)
    # empty list ==> non-transitive linking for everything that links to
    # libplplotdmdd in the shared libraries case.
    target_link_libraries(plplotdmd LINK_INTERFACE_LIBRARIES)
  endif(NON_TRANSITIVE)

  install(TARGETS plplotdmd
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
  )

  # Configure pkg-config *.pc file corresponding to libplplotdmd
  pkg_config_file("d" "D" " D binding" "plplotdmd" "" "")
endif(ENABLE_d)

=== bindings/f95/CMakeLists.txt ===
# bindings/f95/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Andrew Ross
# Copyright (C) 2006-2015 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_f95)

  # Set the include path
  include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    )

  ## Build C part of F95 bindings
  if(WIN32_OR_CYGWIN)
    # Set the flags for the C compiler. The C stubs need to have the
    # correct case and calling convention for the Fortran compiler
    IF(TARGET_FORTRAN MATCHES "IVF")
      SET(DEFFILE "_ifort")
      SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /DIVF")
    ELSEIF(TARGET_FORTRAN MATCHES "CVF")
      SET(DEFFILE "")
      SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /DCVF")
    ENDIF(TARGET_FORTRAN MATCHES "IVF")
  endif(WIN32_OR_CYGWIN)

  set(plplotf95c_LIB_SRCS
    sc3d.c
    sccont.c
    scstubs.c
    )

  if(BUILD_SHARED_LIBS)
    set_source_files_properties(${plplotf95c_LIB_SRCS}
      PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
  endif(BUILD_SHARED_LIBS)

  add_library(plplotf95c ${plplotf95c_LIB_SRCS})

  target_link_libraries(plplotf95c  plplot)

  if(USE_RPATH)
    get_target_property(LIB_INSTALL_RPATH plplot INSTALL_RPATH)
    set_target_properties(plplotf95c
      PROPERTIES
      SOVERSION ${plplotf95_SOVERSION}
      VERSION ${plplotf95_VERSION}
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(plplotf95c
      PROPERTIES
      SOVERSION ${plplotf95_SOVERSION}
      VERSION ${plplotf95_VERSION}
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  endif(USE_RPATH)

  install(TARGETS plplotf95c
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
    )

  # Build fortran part of F95 bindings.
  # Notes:

  # The CMake Fortran dependency scanner finds the Fortran include
  # files, sfstubs.inc and plplot_parameters.inc and deals properly
  # with the dependencies on those files.  Therefore, there is no need
  # to include those files in the SRCS list or do anything special
  # with their dependencies.

  # Check consistency of plplot_parameters.inc.
  add_custom_target(
    check_f95_parameters
    ${CMAKE_COMMAND} -E echo "Check that bindings/f95/plplot_parameters.inc is consistent with the #defines in bindings/swig-support/plplotcapi.i"
    COMMAND ${CMAKE_COMMAND} -E remove -f
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_parameters.inc_compare
    COMMAND
    sed -f ${CMAKE_CURRENT_SOURCE_DIR}/global_defines.sed <
    ${CMAKE_SOURCE_DIR}/bindings/swig-support/plplotcapi.i >
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_parameters.inc_compare
    COMMAND
    COMMAND
    cmp ${CMAKE_CURRENT_SOURCE_DIR}/plplot_parameters.inc
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_parameters.inc_compare
    )

  add_dependencies(check_all check_f95_parameters)

  # Configure the Fortran source file that specifies the
  # types used for PLplot.
  if(PL_DOUBLE)
    set(ONE_IN_DEFAULT_PRECISION "1.0d0")
  else(PL_DOUBLE)
    set(ONE_IN_DEFAULT_PRECISION "1.0")
  endif(PL_DOUBLE)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/plplot_types.f90.in
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_types.f90
    @ONLY
    )

  set(plplotf95_LIB_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_types.f90
    strutil.f90
    plparseopts.f90
    sfstubsf95.f90
    )

  if(WIN32_AND_NOT_CYGWIN AND BUILD_SHARED_LIBS AND NOT MINGW)
    SET(plplotf95_LIB_SRCS ${plplotf95_LIB_SRCS} plplotf95${DEFFILE}.def)
  endif(WIN32_AND_NOT_CYGWIN AND BUILD_SHARED_LIBS AND NOT MINGW)

  add_library(plplotf95 ${plplotf95_LIB_SRCS})

  if(NON_TRANSITIVE)
    # empty list ==> non-transitive linking for everything that links to
    # libplplotf95cd and libplplotf95d in the shared libraries case.
    target_link_libraries(plplotf95c LINK_INTERFACE_LIBRARIES)
    target_link_libraries(plplotf95 LINK_INTERFACE_LIBRARIES)
  endif(NON_TRANSITIVE)

  target_link_libraries(plplotf95  plplotf95c)

  if(USE_RPATH)
    set_target_properties(plplotf95
      PROPERTIES
      SOVERSION ${plplotf95_SOVERSION}
      VERSION ${plplotf95_VERSION}
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(plplotf95
      PROPERTIES
      SOVERSION ${plplotf95_SOVERSION}
      VERSION ${plplotf95_VERSION}
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  endif(USE_RPATH)

  # Set the path and the suffix for the (shared) libraries
  if(CYGWIN)
    if(BUILD_SHARED_LIBS)
      set(SHLIB_DIR "${BIN_DIR}")
    endif(BUILD_SHARED_LIBS)
    set(VERSION_SUFFIX "-${plplotf95_VERSION}")
  else(CYGWIN)
    set(VERSION_SUFFIX "")
  endif(CYGWIN)

  install(TARGETS plplotf95
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
    )

  # For CMake-2.6.0 and above, the module files are created by
  # default during the library build in the bindings/f95 directory.
  install(
    FILES
    ${CMAKE_BINARY_DIR}/bindings/f95/plplot.mod
    ${CMAKE_BINARY_DIR}/bindings/f95/plplotp.mod
    ${CMAKE_BINARY_DIR}/bindings/f95/plplot_types.mod
    ${CMAKE_BINARY_DIR}/bindings/f95/plplot_graphics.mod
    ${CMAKE_BINARY_DIR}/bindings/f95/plplot_str.mod
    ${CMAKE_BINARY_DIR}/bindings/f95/plplot_strutils.mod
    DESTINATION ${F95_MOD_DIR}
    )

  # Configure pkg-config *.pc file corresponding to libplplotf95
  pkg_config_file("f95" "F95" " F95 binding" "plplotf95${VERSION_SUFFIX}" "-I\"${F95_MOD_DIR}\"" "-lplplotf95c${VERSION_SUFFIX}")
endif(ENABLE_f95)

=== bindings/gnome2/CMakeLists.txt ===
# Order is important here.  lib must be first since python depends upon it.
add_subdirectory(lib) 
add_subdirectory(python)

=== debian/changelog ===
pftools (3.2.12-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with nocheck build profile. Closes: #1103318.
    Thanks to Nilesh Patra.
  * Enable nocheck build profile job in Salsa CI.
  * Drop "Rules-Requires-Root: no", no longer needed.
  * Upldate lintian overrides.
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Sat, 27 Sep 2025 22:55:00 +0200

pftools (3.2.12-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 3.2.12
  * Refresh patches
  * d/rules:
    + Re-enable regex support now that pcre2 support is added
    + Add linker flags for pcre2 to LDFLAGS
  * d/control: Add libpcre2-dev to B-D

 -- Nilesh Patra <nilesh@debian.org>  Sat, 26 Mar 2022 21:23:28 +0530

=== debian/control ===
Source: pftools
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               gfortran,
               cmake,
               libfile-slurp-perl,
               libbz2-dev,
               libreadline-dev,
               libpcre2-dev,
               zlib1g-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/pftools
Vcs-Git: https://salsa.debian.org/med-team/pftools.git
Homepage: https://github.com/sib-swiss/pftools3

Package: pftools
Architecture: any-amd64
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libfile-slurp-perl
Description: build and search protein and DNA generalized profiles
 The pftools package contains all the software necessary to build protein
 and DNA generalized profiles and use them to scan and align sequences,
 and search databases.
 .
 File formats used by the pftools
  * Generalized profiles format and syntax.
  * The multiple sequence alignment format (PSA).
  * The extended header multiple sequence alignment format (XPSA).
 .
 Programs to build generalized profiles
  pfmake
    Build a profile from a multiple sequence alignment.
  pfscale
    Fit parameters of an extreme-value distribution to a profile score list.
  pfw
    Weight sequences of a multiple sequence alignment to correct for
    sampling bias.
 .
 Programs to search with generalized profiles
  pfsearch / pfsearchV3
    Search a protein or DNA sequence library for sequence segments matching
    a profile (V3 is the new version of this tool).
  pfscan
    Scan a protein or DNA sequence with a profile library
 .
 Conversion programs
  psa2msa
    Reformat PSA file to Pearson/Fasta multiple sequence alignment file.
  ptof
    Convert a protein profile into a frame-search profile to search DNA
    sequences. To be used with 2ft.
  2ft
    Converts both strands of DNA into so-called interleaved
    frame-translated DNA sequences to search with protein profiles. To be
    used with ptof.
  6ft
    Translates all six reading frames of a double-stranded DNA sequence
    into individual protein sequences.
  pfgtop
    Convert a profile in GCG format into PROSITE format.
  pfhtop
    Convert a HMMER1 ASCII-formatted HMM into an equivalent PROSITE profile.
  ptoh
    Converts a generalized profile into an approximately equivalent HMM
    profile in HMMER1 format (can be read by the hmmconvert program from
    the HMMER2 package).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/default.mk
export DEB_LDFLAGS_MAINT_APPEND = -lpcre2-8


%:
	dh $@

override_dh_auto_configure:
	if [ ! -e src/C/config.h.cmake ] ; then cp -a debian/missing-sources/config.h.cmake src/C/ ; fi
	dh_auto_configure

override_dh_auto_install:
	dh_auto_install
	# Avoid name spacing conflict with htop and consequently also rename gtop
	mv debian/$(DEB_SOURCE)/usr/bin/gtop debian/$(DEB_SOURCE)/usr/bin/pfgtop
	mv debian/$(DEB_SOURCE)/usr/bin/htop debian/$(DEB_SOURCE)/usr/bin/pfhtop

override_dh_installexamples:
	dh_installexamples
	cp -a debian/pftools/usr/share/examples/* debian/pftools/usr/share/doc/pftools/examples/
	rm -rf debian/pftools/usr/share/data/ debian/pftools/usr/share/examples/

override_dh_installman:
	dh_installman
	mv debian/$(DEB_SOURCE)/usr/share/man/man1/gtop.1 debian/$(DEB_SOURCE)/usr/share/man/man1/pfgtop.1
	mv debian/$(DEB_SOURCE)/usr/share/man/man1/htop.1 debian/$(DEB_SOURCE)/usr/share/man/man1/pfhtop.1
	mv debian/$(DEB_SOURCE)/usr/share/doc/*.pdf debian/$(DEB_SOURCE)/usr/share/doc/${DEB_SOURCE}/
	rm -f debian/$(DEB_SOURCE)/usr/share/doc/*.txt debian/${DEB_SOURCE}/usr/ChangeLog debian/${DEB_SOURCE}/usr/README* debian/${DEB_SOURCE}/usr/LICENSE

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -rf data/test.*

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/sib-swiss/pftools3/tags .*/v?@ANY_VERSION@\.tar\.gz
